"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const insert_text_textarea_1 = __importDefault(require("insert-text-textarea"));
function indentTextarea(el) {
    const { selectionStart, selectionEnd, value } = el;
    const linesCount = value.slice(selectionStart, selectionEnd).match(/^|\n/g).length;
    if (linesCount > 1) {
        // Select full first line to replace everything at once
        const firstLineStart = value.lastIndexOf('\n', selectionStart) + 1;
        el.setSelectionRange(firstLineStart, selectionEnd);
        const newSelection = el.value.slice(firstLineStart, selectionEnd);
        const indentedText = newSelection.replace(/^|\n/g, // Match all line starts
        '$&\t');
        // Replace newSelection with indentedText
        insert_text_textarea_1.default(el, indentedText);
        // Restore selection position, including the indentation
        el.setSelectionRange(selectionStart + 1, selectionEnd + linesCount);
    }
    else {
        insert_text_textarea_1.default(el, '\t');
    }
}
function watchListener(event) {
    const tsEvent = event; // TODO: find a way around this ugly TypeScript workaround
    if (tsEvent.key === 'Tab' && !tsEvent.shiftKey) {
        indentTextarea(tsEvent.target);
        tsEvent.preventDefault();
    }
}
function watchAndIndent(elements) {
    if (typeof elements === 'string') {
        elements = document.querySelectorAll(elements);
    }
    else if (elements instanceof HTMLTextAreaElement) {
        elements = [elements];
    }
    for (const element of elements) {
        element.addEventListener('keydown', watchListener);
    }
}
indentTextarea.watch = watchAndIndent;
module.exports = indentTextarea;
//# sourceMappingURL=index.js.map